package ca.dal.cs.schememm.parser.builder;

import ca.dal.cs.schememm.scanner.Token;

import java.io.StringWriter;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

class Rule {

    /**
     * Construct a new rule with the given head and the given production
     * @param head the left-hand side of the rule
     * @param production the right-hand side of the rule
     */
    Rule(NonTerminal head, List<Symbol> production) {
        this.head = head;
        this.production = production;
        predictSet = new HashSet<>();
    }

    @Override
    public String toString() {
        StringWriter w = new StringWriter();
        w.write(head.name());
        w.write(" -->");
        for (Symbol sym : production) {
            w.write(' ');
            w.write(sym.name());
        }
        return w.toString();
    }

    NonTerminal     head;
    List<Symbol>    production;
    Set<Token.Name> predictSet;
}
