package ca.dal.cs.schememm.parser.parsetree;

/**
 * The base class of all parse tree nodes
 */
public abstract class Node {

    Node(NonTerminal parent) {
        if (parent != null) {
            parent.addChild(this);
        }
    }

    /**
     * Print this node to the screen
     *
     * @param prefix a prefix to be printed before this node
     */
    public abstract void format(String prefix);

    /**
     * Cast this node to a terminal
     *
     * @return the node cast to a terminal
     */
    public Terminal asTerminal() {
        return null;
    }

    /**
     * Cast this node to a non-terminal
     *
     * @return the node cast to a non-terminal
     */
    public NonTerminal asNonTerminal() {
        return null;
    }
}
