package ca.dal.cs.schememm.parser.parsetree;

import ca.dal.cs.schememm.scanner.Token;

/**
 * A parse tree leaf representing a terminal
 */
public class Terminal extends Node {

    public Terminal(NonTerminal parent, Token.Name name) {
        super(parent);
        token = new Token(name, "");
    }

    @Override
    public void format(String prefix) {
        System.out.printf("%s%s (%s)\n", prefix, token.name(), token.string());
    }

    @Override
    public Terminal asTerminal() {
        return this;
    }

    public Token.Name name() {
        return token.id();
    }

    public void setString(String string) {
        token = new Token(token.id(), string);
    }

    private Token token;
}
