package ca.dal.cs.schememm.scanner.fa;

import ca.dal.cs.schememm.common.Pair;
import org.testng.annotations.Test;

import java.util.HashSet;
import java.util.Set;

import static org.testng.Assert.*;

public class StateTest {

    @Test
    public void testCollectStates() {
        State      s0        = new State(null);
        State      s1        = new State(null);
        State      s2        = new State(null);
        State      s3        = new State(null);
        State      s4        = new State(null);
        State      s5        = new State(null);
        Set<State> collected = new HashSet<>();

        s0.addTransition(null, s1);
        s0.addTransition(new Pair<>(12, 13), s2);
        s0.addTransition(new Pair<>(27, 48), s2);
        s0.addTransition(null, s4);
        s1.addTransition(null, s2);
        s1.addTransition(new Pair<>(27, 48), s3);
        s2.addTransition(null, s4);
        s3.addTransition(null, s4);
        s4.addTransition(new Pair<>(77, 88), s1);
        s4.addTransition(new Pair<>(100, 110), s2);
        s5.addTransition(null, s2);
        s5.addTransition(new Pair<>(100, 105), s3);

        State.collectStates(s0, collected);
        assertEquals(collected.size(), 5);
        assertTrue(collected.contains(s0));
        assertTrue(collected.contains(s1));
        assertTrue(collected.contains(s2));
        assertTrue(collected.contains(s3));
        assertTrue(collected.contains(s4));
    }

    @Test
    public void testTransition() {
        State from = new State(null);
        State nbr1 = new State(null);
        State nbr2 = new State(null);
        State nbr3 = new State(null);

        from.addTransition(new Pair<>(12, 23), nbr1);
        from.addTransition(new Pair<>(48, 51), nbr2);
        from.addTransition(new Pair<>(97, 107), nbr3);

        assertSame(from.transition(12), nbr1);
        assertSame(from.transition(20), nbr1);
        assertSame(from.transition(23), nbr1);
        assertSame(from.transition(48), nbr2);
        assertSame(from.transition(49), nbr2);
        assertSame(from.transition(51), nbr2);
        assertSame(from.transition(100), nbr3);
        assertSame(from.transition(11), null);
        assertSame(from.transition(24), null);
    }
}
